PROGRAM DOMINO;

USES
  GRAPH,CRT;

CONST
  GRAPHDRIVER : INTEGER=DETECT;
  BOX : ARRAY[1..4] OF POINTTYPE=((x:1;y:1),
        (x:639;y:1),(x:639;y:63),(x:1;y:63));
  vsize=79;
  hsize=41;
VAR
  Y, SIZE,int: INTEGER;
  GRAPHMODE : INTEGER;
  choice,choice3,choice2,again,verthor,upplow,verthor2,upplow2 : CHAR;

{***************************************************************************}
Procedure UpScroll(xcord:integer;c:string);
var y:integer;
begin
   y:=470;
   repeat
      Setcolor(0);
      settextstyle(1,horizdir,8);
      outtextxy(xcord,y,c);
      y:=y-8;
      Setcolor(10);
      settextstyle(1,horizdir,8);
      outtextxy(xcord,y,c);
      DELAY(2);
    until y<=180;
end;
{***************************************************************************}
Procedure UpScroll2(xcord:integer;c:string);
var y:integer;
begin
   y:=470;
   repeat
      Setcolor(0);
      settextstyle(1,horizdir,5);
      outtextxy(xcord,y,c);
      y:=y-6;
      Setcolor(random(14+1));
      settextstyle(1,horizdir,5);
      outtextxy(xcord,y,c);
      delay(50);
    until y<=280;
end;

{***************************************************************************}
Procedure downScroll(xcord:integer;c:char);
var y:integer;
begin
   y:=170;
   repeat
      Setcolor(0);
      settextstyle(4,horizdir,8);
      outtextxy(xcord,y,c);
      y:=y+7;
      Setcolor(10);
      settextstyle(4,horizdir,8);
      outtextxy(xcord,y,c);
      DELAY(2);
    until y>=460;
end;
{**************************************************************************}
procedure error_message1;
begin
  setcolor(0);
  SETTEXTSTYLE(1,HORIZDIR,2);
  OUTTEXTXY(330,420,'CHOOSE DOMINO:');
  setcolor(12);
  SETTEXTSTYLE(1,HORIZDIR,2);
  outtextxy(400,420,'WRONG DOMINO');
  delay(1000);
  setcolor(0);
  SETTEXTSTYLE(1,HORIZDIR,2);
  outtextxy(400,420,'WRONG DOMINO');
end;

procedure error_message2;
begin
  setcolor(0);
  SETTEXTSTYLE(1,HORIZDIR,2);
  OUTTEXTXY(330,420,'CHOOSE DOMINO:');
  setcolor(12);
  SETTEXTSTYLE(1,HORIZDIR,2);
  outtextxy(400,420,'WRONG POSITION');
  delay(1000);
  setcolor(0);
  SETTEXTSTYLE(1,HORIZDIR,2);
  outtextxy(400,420,'WRONG POSITION');
end;

{***************************************************************************}
procedure asking;
begin
  setcolor(0);
  SETTEXTSTYLE(1,HORIZDIR,2);
  OUTTEXTXY(330,420,'CHOOSE DOMINO:');

  setcolor(10);
  SETTEXTSTYLE(1,HORIZDIR,2);
  OUTTEXTXY(330,410,'ENTER POSITION');

  setcolor(10);
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(364,437,'ERTICAL');
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(365,454,'ORIZONTAL');
  setcolor(12);
  SETTEXTSTYLE(2,HORIZDIR,7);
  OUTTEXTXY(350,435,'V');
  SETTEXTSTYLE(2,HORIZDIR,7);
  OUTTEXTXY(350,451,'H');
  repeat
    verthor:=readkey;
    verthor:=upcase(verthor);
  until (verthor='V') or (verthor='H');

  setcolor(0);
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(364,437,'ERTICAL');
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(365,454,'ORIZONTAL');
  SETTEXTSTyLE(2,HORIZDIR,7);
  OUTTEXTXY(350,435,'V');
  SETTEXTSTYLE(2,HORIZDIR,7);
  OUTTEXTXY(350,451,'H');


  setcolor(10);
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(364,437,'PPER PART');
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(365,454,'OWER PART');
  setcolor(12);
  SETTEXTSTYLE(2,HORIZDIR,7);
  OUTTEXTXY(350,435,'U');
  SETTEXTSTYLE(2,HORIZDIR,7);
  OUTTEXTXY(350,451,'L');
  repeat
    upplow:=readkey;
    upplow:=upcase(upplow);
  until (upplow='L') or (upplow='U');

  setcolor(0);
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(364,437,'PPER PART');
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(365,454,'OWER PART');
  SETTEXTSTYLE(2,HORIZDIR,7);
  OUTTEXTXY(350,435,'U');
  SETTEXTSTYLE(2,HORIZDIR,7);
  OUTTEXTXY(350,451,'L');
  SETTEXTSTYLE(1,HORIZDIR,2);
  OUTTEXTXY(330,410,'ENTER POSITION');

end;
procedure asking2;
begin
  setcolor(0);
  SETTEXTSTYLE(1,HORIZDIR,2);
  OUTTEXTXY(330,420,'CHOOSE DOMINO:');

  setcolor(10);
  SETTEXTSTYLE(1,HORIZDIR,2);
  OUTTEXTXY(330,410,'ENTER POSITION');

  setcolor(10);
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(364,437,'ERTICAL');
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(365,454,'ORIZONTAL');
  setcolor(12);
  SETTEXTSTYLE(2,HORIZDIR,7);
  OUTTEXTXY(350,435,'V');
  SETTEXTSTYLE(2,HORIZDIR,7);
  OUTTEXTXY(350,451,'H');
  repeat
    verthor2:=readkey;
    verthor2:=upcase(verthor2);
  until (verthor2='V') or (verthor2='H');

  setcolor(0);
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(364,437,'ERTICAL');
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(365,454,'ORIZONTAL');
  SETTEXTSTyLE(2,HORIZDIR,7);
  OUTTEXTXY(350,435,'V');
  SETTEXTSTYLE(2,HORIZDIR,7);
  OUTTEXTXY(350,451,'H');


  setcolor(10);
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(364,437,'PPER PART');
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(365,454,'OWER PART');
  setcolor(12);
  SETTEXTSTYLE(2,HORIZDIR,7);
  OUTTEXTXY(350,435,'U');
  SETTEXTSTYLE(2,HORIZDIR,7);
  OUTTEXTXY(350,451,'L');
  repeat
    upplow2:=readkey;
    upplow2:=upcase(upplow2);
  until (upplow2='L') or (upplow2='U');

  setcolor(0);
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(364,437,'PPER PART');
  SETTEXTSTYLE(2,HORIZDIR,6);
  OUTTEXTXY(365,454,'OWER PART');
  SETTEXTSTYLE(2,HORIZDIR,7);
  OUTTEXTXY(350,435,'U');
  SETTEXTSTYLE(2,HORIZDIR,7);
  OUTTEXTXY(350,451,'L');
  SETTEXTSTYLE(1,HORIZDIR,2);
  OUTTEXTXY(330,410,'ENTER POSITION');

end;

{**************************************************************************}
PROCEDURE THINKING;
begin
  setcolor(5);
  SETTEXTSTYLE(1,HORIZDIR,2);
  OUTTEXTXY(330,420,'THINKING...');
  delay (1000);
  setcolor(0);
  SETTEXTSTYLE(1,HORIZDIR,2);
  OUTTEXTXY(330,420,'THINKING...');
end;

{**************************************************************************}
PROCEDURE SIX(A,B,T:integer);
BEGIN
 int:=1*T;
 FILLELLIPSE(A,B,int,int);
 FILLELLIPSE(A+8*T,B,int,int);
 FILLELLIPSE(A,B+4*T,int,int);
 FILLELLIPSE(A+8*T,B+4*T,int,int);
 FILLELLIPSE(A,B+8*T,int,int);
 FILLELLIPSE(A+8*T,B+8*T,int,int);
END;
{***************************************************************************}
PROCEDURE SIXh(A,B,T:INTEGER);
BEGIN
 int:=1*T;
 FILLELLIPSE(A,B,int,int);
 FILLELLIPSE(A+4*T,B,int,int);
 FILLELLIPSE(A+8*t,B,int,int);
 FILLELLIPSE(A,B+8*T,int,int);
 FILLELLIPSE(A+4*t,B+8*T,int,int);
 FILLELLIPSE(A+8*t,B+8*T,int,int);
END;

{***************************************************************************}
PROCEDURE FIVE(A,B,T:INTEGER);
BEGIN
 int:=1*T;
 FILLELLIPSE(A,B,int,int);
 FILLELLIPSE(A+8*T,B,int,int);
 FILLELLIPSE(A+4*T,B+4*T,int,int);
 FILLELLIPSE(A,B+8*T,int,int);
 FILLELLIPSE(A+8*T,B+8*T,int,int);
END;
{***************************************************************************}
PROCEDURE FOUR(A,B,T:INTEGER);
BEGIN
 int:=1*T;
 FILLELLIPSE(A,B,int,int);
 FILLELLIPSE(A+8*T,B,int,int);
 FILLELLIPSE(A,B+8*T,int,int);
 FILLELLIPSE(A+8*T,B+8*T,int,int);
END;
{***************************************************************************}
PROCEDURE THREE(A,B,T:INTEGER);
BEGIN
 int:=1*T;
 FILLELLIPSE(A,B,int,int);
 FILLELLIPSE(A+4*T,B+4*T,int,int);
 FILLELLIPSE(A+8*T,B+8*T,int,int);
END;
{***************************************************************************}
PROCEDURE TWO(A,B,T:INTEGER);
BEGIN
 int:=1*T;
 FILLELLIPSE(A,B,int,int);
 FILLELLIPSE(A+8*T,B+8*T,int,int);
END;
{***************************************************************************}
PROCEDURE ONE(A,B,T:INTEGER);
BEGIN
 int:=1*T;
 FILLELLIPSE(A,B,int,int);
END;
{***************************************************************************}
PROCEDURE DOMINOv(X,Y,T,N,M:INTEGER);
 BEGIN
   RECTANGLE(X,Y,X+20*T,Y+20*T);
   RECTANGLE(X,Y+20*T,X+20*T,Y+40*T);
    CASE N OF
      1:ONE(X+10*T,Y+10*T,T);
      2:TWO(X+6*T,Y+6*T,T);
      3:THREE(X+6*T,Y+6*T,T);
      4:FOUR(X+6*T,Y+6*T,T);
      5:FIVE(X+6*T,Y+6*T,T);
      6:SIX(X+6*T,Y+6*T,T);
    END;
    CASE M OF
     1:ONE(X+10*T,Y+30*T,T);
     2:TWO(X+6*T,Y+26*T,T);
     3:THREE(X+6*T,Y+26*T,T);
     4:FOUR(X+6*T,Y+26*T,T);
     5:FIVE(X+6*T,Y+26*T,T);
     6:SIX(X+6*T,Y+26*T,T);
    END;
 END;
{***************************************************************************}
PROCEDURE DOMINOh(X,Y,T,N,M:INTEGER);
 BEGIN
   RECTANGLE(X,Y,X+20*T,Y+20*T);
   RECTANGLE(X+20*t,y,X+40*T,Y+20*T);
    CASE N OF
      1:ONE(X+10*T,Y+10*T,T);
      2:TWO(X+6*T,Y+6*T,T);
      3:THREE(X+6*T,Y+6*T,T);
      4:FOUR(X+6*T,Y+6*T,T);
      5:FIVE(X+6*T,Y+6*T,T);
      6:SIXh(X+6*T,Y+6*T,T);
    END;
    CASE M OF
     1:ONE(X+30*T,Y+10*T,T);
     2:TWO(X+26*T,Y+6*T,T);
     3:THREE(X+26*T,Y+6*T,T);
     4:FOUR(X+26*T,Y+6*T,T);
     5:FIVE(X+26*T,Y+6*T,T);
     6:SIXh(X+26*T,Y+6*T,T);
    END;
 END;
{***************************************************************************}
procedure chsedmno;
begin
    repeat
      setcolor(14);
      SETTEXTSTYLE(1,HORIZDIR,2);
      OUTTEXTXY(330,420,'CHOOSE DOMINO:');
      choice:=READKEY;
      choice:=upcase(choice);
      SETCOLOR(0);
      CASE choice OF
        'A':begin
              error_message1;
            end;

        'B':begin
              error_message1;
            end;

        'C':begin
             setcolor(0);
             dominov(100,420,1,6,2);
             SETTEXTSTYLE(1,HORIZDIR,1);
             outtextxy(100,415,'||||||||||');
             outtextxy(100,420,'||||||||||');
             outtextxy(100,430,'||||||||||');
             outtextxy(100,440,'||||||||||');
             setcolor(12);
             outtextxy(100,414,'|||||||||||');
             outtextxy(100,420,'|||||||||||');
             outtextxy(100,430,'|||||||||||');
             outtextxy(100,443,'|||||||||||');
           end;

        'D':begin
              error_message1;
            end;

        'E':begin
             setcolor(0);
             dominov(180,420,1,6,0);
             SETTEXTSTYLE(1,HORIZDIR,1);
             outtextxy(180,415,'||||||||||');
             outtextxy(180,420,'||||||||||');
             outtextxy(180,430,'||||||||||');
             outtextxy(180,440,'||||||||||');
             setcolor(12);
             outtextxy(180,414,'|||||||||||');
             outtextxy(180,420,'|||||||||||');
             outtextxy(180,430,'|||||||||||');
             outtextxy(180,443,'|||||||||||');
           end;

        'F':begin
              error_message1;
            end;

        'G':begin
              error_message1;
            end;
        'Q':again:='N';
        end;{case}
      until (choice='C') or (choice='E') or (choice='Q');
end;

procedure chsedmno2;
begin
    repeat
      setcolor(14);
      SETTEXTSTYLE(1,HORIZDIR,2);
      OUTTEXTXY(330,420,'CHOOSE DOMINO:');
      choice2:=READKEY;
      choice2:=upcase(choice2);
      SETCOLOR(0);
      CASE choice2 OF
        'A':begin
              error_message1;
            end;

        'B':begin
              error_message1;
            end;

        'C':begin
             error_message1;
           end;

        'D':begin
              error_message1;
            end;

        'E':begin
             setcolor(0);
             dominov(180,420,1,6,0);
             SETTEXTSTYLE(1,HORIZDIR,1);
             outtextxy(180,415,'||||||||||');
             outtextxy(180,420,'||||||||||');
             outtextxy(180,430,'||||||||||');
             outtextxy(180,440,'||||||||||');
             setcolor(12);
             outtextxy(180,414,'|||||||||||');
             outtextxy(180,420,'|||||||||||');
             outtextxy(180,430,'|||||||||||');
             outtextxy(180,443,'|||||||||||');
           end;

        'F':begin
              error_message1;
            end;

        'G':begin
              error_message1;
            end;
        'Q':again:='N';
        end;{case}
      until (choice2='E') or (choice2='Q');
end;
procedure chsedmno3;
begin
    repeat
      setcolor(14);
      SETTEXTSTYLE(1,HORIZDIR,2);
      OUTTEXTXY(330,420,'CHOOSE DOMINO:');
      choice3:=READKEY;
      choice3:=upcase(choice3);
      SETCOLOR(0);
      CASE choice3 OF
        'A':begin
              error_message1;
            end;

        'B':begin
              error_message1;
            end;

        'C':begin
             setcolor(0);
             dominov(100,420,1,6,2);
             SETTEXTSTYLE(1,HORIZDIR,1);
             outtextxy(100,415,'||||||||||');
             outtextxy(100,420,'||||||||||');
             outtextxy(100,430,'||||||||||');
             outtextxy(100,440,'||||||||||');
             setcolor(12);
             outtextxy(100,414,'|||||||||||');
             outtextxy(100,420,'|||||||||||');
             outtextxy(100,430,'|||||||||||');
             outtextxy(100,443,'|||||||||||');
           end;

        'D':begin
              error_message1;
            end;

        'E':begin
             error_message1;
           end;

        'F':begin
              error_message1;
            end;

        'G':begin
              error_message1;
            end;
        'Q':again:='N';
        end;{case}
      until (choice3='C') or (choice3='Q');
end;
procedure coverplyr;
var y:integer;
begin
y:=350;
SETTEXTSTYLE(1,HORIZDIR,1);
setcolor(12);
outtextxy(100+y,414,'|||||||||||');
outtextxy(100+y,420,'|||||||||||');
outtextxy(100+y,430,'|||||||||||');
outtextxy(100+y,443,'|||||||||||');
outtextxy(180+y,414,'|||||||||||');
outtextxy(180+y,420,'|||||||||||');
outtextxy(180+y,430,'|||||||||||');
outtextxy(180+y,443,'|||||||||||');
end;
procedure covercomp;
begin
SETTEXTSTYLE(1,HORIZDIR,1);
setcolor(12);
outtextxy(20,414,'|||||||||||');
outtextxy(20,420,'|||||||||||');
outtextxy(20,430,'|||||||||||');
outtextxy(20,443,'|||||||||||');
end;
{***************************************************************************}
procedure computerdisp;
begin
      SETCOLOR(4);
      dominov(20,420,1,6,6);
      dominov(60,420,1,2,5);
      dominov(101,421,1,0,4);
      dominov(140,420,1,0,1);
      dominov(181,421,1,2,3);
      dominov(220,420,1,3,4);
      dominov(260,420,1,1,1);
end;

procedure userdisply;
begin
      SETCOLOR(9);               {user's display}
      dominov(20,420,1,3,3);
      dominov(60,420,1,0,3);
      dominov(100,420,1,6,2);
      dominov(140,420,1,0,0);
      dominov(180,420,1,6,0);
      dominov(220,420,1,2,2);
      dominov(260,420,1,1,3);
end;

procedure userdisplay2;
var
  x:integer;
begin
  x:=350;
      SETCOLOR(9);               {user's display}
      dominov(20+x,420,1,3,3);
      dominov(60+x,420,1,0,3);
      dominov(100+x,420,1,6,2);
      dominov(140+x,420,1,0,0);
      dominov(180+x,420,1,6,0);
      dominov(220+x,420,1,2,2);
      dominov(260+x,420,1,1,3);
end;

procedure marks;
begin
  setcolor(1);
  settextstyle(1,horizdir,5);
  outtextxy(100,80,'Computer Vs Player');
  outtextxy(100,130,'   19        17  ');
  settextstyle(1,horizdir,8);
  setcolor(4);
  outtextxy(140,230,'YOU WIN');
end;

procedure marks1;
begin
  setcolor(1);
  settextstyle(1,horizdir,5);
  outtextxy(100,80,'Computer Vs Player');
  outtextxy(100,130,'   22         17  ');
  settextstyle(1,horizdir,8);
  setcolor(4);
  outtextxy(140,230,'YOU WIN');
end;

{===========================================================================}
BEGIN
  INITGRAPH(GRAPHDRIVER, GRAPHMODE, 'c:\tp\bgi'); { Sets to default mode }
  SETBKCOLOR(0);
  setcolor(10);             {screen layout}
  upscroll(109,'D');
  upscroll(169,'O');
  upscroll(220,'M');
  upscroll(290,'I');
  upscroll(330,'N');
  upscroll(390,'O');
  upscroll(445,'E');
  upscroll(505,'S');
  upscroll2(160,'PLAYABLE DEMO');
  delay(1000);
repeat
  cleardevice;
  setcolor(8);
  settextstyle(4,horizdir,10);
  outtextxy(140,120,'DEMO');
  SETCOLOR(10);
  lINE(0,400,639,400 );
  SETCOLOR(10);
  RECTANGLE(0, 0, 639, 479);
  SETLINESTYLE (0,3,2);
  SETCOLOR(10);
  LINE(310,400,310,580);

      userdisply;
      dominov(300,180,2,6,6);

    SETCOLOR(14);
    SETTEXTSTYLE(14,HORIZDIR,1);
    OUTTEXTXY(15,405,'YOUR DOMINOES');
    outtextxy(26,467,'A');
    outtextxy(67,467,'B');
    outtextxy(107,467,'C');
    outtextxy(147,467,'D');
    outtextxy(187,467,'E');
    outtextxy(227,467,'F');
    outtextxy(267,467,'G');
    setcolor(12);
    outtextxy(235,405,'Q : Quit');
    chsedmno;


      if (choice='C') then
      begin
        asking;
        if (verthor='V') and (upplow='L') then begin
          setcolor(9);
          dominov(300,181+vsize,2,6,2);
          thinking;
          setcolor(9);
          dominoh(300+hsize,180+vsize+41,2,2,5);
          chsedmno2;
          if (choice2='E') then begin
          repeat
            asking2;
            setcolor(9);
            if (verthor2='H') and (upplow2='U') then dominoh(260,180-41,2,0,6);
            if (verthor2='H') and (upplow2='L') then Error_message2;
            if (verthor2='V') and (upplow2='L') then error_message2;
            if (verthor2='V') and (upplow2='U') then dominov(300,180-81,2,0,6);
          until ((verthor2='H') and (upplow2='U')) or ((verthor2='V') and (upplow2='U'));
         end;
        end;

        if (verthor='H') and (upplow='L') then begin
          setcolor(9);
          dominoh(300,182+vsize,2,6,2);
          thinking;
          setcolor(9);
          dominoh(300+Vsize,182+vsize,2,2,5);
          chsedmno2;
          if (choice2='E') then begin
          repeat
            asking2;
            setcolor(9);
            if (verthor2='H') and (upplow2='U') then dominoh(260,180-41,2,0,6);
            if (verthor2='H') and (upplow2='L') then Error_message2;
            if (verthor2='V') and (upplow2='L') then error_message2;
            if (verthor2='V') and (upplow2='U') then dominov(300,180-81,2,0,6);
          until ((verthor2='H') and (upplow2='U')) or ((verthor2='V') and (upplow2='U'));
         end;
        end;

        if (verthor='V') and (upplow='U') then begin
          setcolor(9);
          dominov(300,180-79,2,2,6);
          thinking;
          setcolor(9);
          dominoh(300+hsize,180-vsize,2,2,5);
          chsedmno2;
          if (choice2='E') then begin
          repeat
            asking2;
            setcolor(9);
            if (verthor2='H') and (upplow2='U') then Error_message2;
            if (verthor2='H') and (upplow2='L') then dominoh(300,261,2,6,0);
            if (verthor2='V') and (upplow2='L') then dominov(300,261,2,6,0);
            if (verthor2='V') and (upplow2='U') then Error_message2;
          until ((verthor2='H') and (upplow2='L')) or ((verthor2='V') and (upplow2='L'));
         end;
        end;

        if (verthor='H') and (upplow='U') then begin
          setcolor(9);
          dominoh(300,180-41,2,6,2);
          thinking;
          setcolor(9);
          dominoh(300+hsize+40,180-hsize,2,2,5);
          chsedmno2;
          if (choice2='E') then begin
          repeat
            asking2;
            setcolor(9);
            if (verthor2='H') and (upplow2='U') then Error_message2;
            if (verthor2='H') and (upplow2='L') then dominoh(300,261,2,6,0);
            if (verthor2='V') and (upplow2='L') then dominov(300,261,2,6,0);
            if (verthor2='V') and (upplow2='U') then Error_message2;
          until ((verthor2='H') and (upplow2='L')) or ((verthor2='V') and (upplow2='L'));
         end;
        end;
        end;


      if (choice='E') then
      begin
        asking;
        if (verthor='V') and (upplow='L') then begin
          setcolor(9);
          dominov(300,181+vsize,2,6,0);
          thinking;
          setcolor(9);
          dominoh(300+hsize,180+vsize+41,2,0,4);
          chsedmno3;
          if (choice3='C') then begin
          repeat
            asking2;
            setcolor(9);
            if (verthor2='H') and (upplow2='U') then dominoh(300,180-40,2,6,2);
            if (verthor2='H') and (upplow2='L') then error_message2;
            if (verthor2='V') and (upplow2='L') then error_message2;
            if (verthor2='V') and (upplow2='U') then dominov(300,180-81,2,2,6);
          until ((verthor2='H') and (upplow2='U')) or ((verthor2='V') and (upplow2='U'));
         end;

        end;

        if (verthor='H') and (upplow='L') then begin
          setcolor(9);
          dominoh(300,180+79,2,6,0);
          thinking;
          setcolor(9);
          dominoh(300+Vsize,180+vsize,2,0,4);
          chsedmno3;
          if (choice3='C') then begin
          repeat
            asking2;
            setcolor(9);
            if (verthor2='H') and (upplow2='U') then dominoh(300,180-40,2,6,2);
            if (verthor2='H') and (upplow2='L') then error_message2;
            if (verthor2='V') and (upplow2='L') then error_message2;
            if (verthor2='V') and (upplow2='U') then dominov(300,180-81,2,2,6);
          until ((verthor2='H') and (upplow2='U')) or ((verthor2='V') and (upplow2='U'));
         end;
        end;

        if (verthor='V') and (upplow='U') then begin
          setcolor(9);
          dominov(300,180-79,2,0,6);
          thinking;
          setcolor(9);
          dominoh(300+hsize,180-vsize,2,0,4);
          chsedmno3;
          if (choice3='C') then begin
          repeat
            asking2;
            setcolor(9);
            if (verthor2='H') and (upplow2='U') then Error_message2;
            if (verthor2='H') and (upplow2='L') then dominoh(300,261,2,6,2);
            if (verthor2='V') and (upplow2='L') then dominov(300,261,2,6,2);
            if (verthor2='V') and (upplow2='U') then Error_message2;
          until ((verthor2='H') and (upplow2='L')) or ((verthor2='V') and (upplow2='L'));
         end;
        end;

        if (verthor='H') and (upplow='U') then begin
          setcolor(9);
          dominoh(300,180-41,2,6,0);
          thinking;
          setcolor(9);
          dominoh(300+hsize+40,180-hsize,2,0,4);
          chsedmno3;
          if (choice3='C') then begin
          repeat
            asking2;
            setcolor(9);
            if (verthor2='H') and (upplow2='U') then Error_message2;
            if (verthor2='H') and (upplow2='L') then dominoh(300,261,2,6,2);
            if (verthor2='V') and (upplow2='L') then dominov(300,261,2,6,2);
            if (verthor2='V') and (upplow2='U') then Error_message2;
          until ((verthor2='H') and (upplow2='L')) or ((verthor2='V') and (upplow2='L'));
         end;
        end;
      end;
      delay(1000);
     cleardevice;
     setbkcolor(15);
     if choice='C' then begin
       setcolor(10);
       outtextxy(20,375,'Computer''s deal');
       outtextxy(370,375,'Your deal');
       computerdisp;
       userdisplay2;
       coverplyr;
       covercomp;
       SETTEXTSTYLE(1,HORIZDIR,1);
       setcolor(12);
       outtextxy(60,414,'|||||||||||');
       outtextxy(60,420,'|||||||||||');
       outtextxy(60,430,'|||||||||||');
       outtextxy(60,443,'|||||||||||');
       marks;
       readln;
     end;
     if choice='E' then begin
       setcolor(10);
       outtextxy(20,375,'Computer''s deal');
       outtextxy(370,375,'Your deal');
       computerdisp;
       userdisplay2;
       coverplyr;
       covercomp;
       SETTEXTSTYLE(1,HORIZDIR,1);
       setcolor(12);
       outtextxy(101,414,'|||||||||||');
       outtextxy(101,420,'|||||||||||');
       outtextxy(101,430,'|||||||||||');
       outtextxy(101,443,'|||||||||||');

       marks1;
       readln;
     end;
     cleardevice;
     setbkcolor(0);
   if choice<>'Q' then begin
   repeat
     setcolor(14);
     SETTEXTSTYLE(4,HORIZDIR,4);
     OUTTEXTXY(180,230,'PLAY AGAIN Y/N:');
     again:=readkey;
     again:=upcase(again);
   until (again='Y') or (again='N');
   end;
until again='N';

      cleardevice;
      SETCOLOR(10);
      SETTEXTSTYLE(4,HORIZDIR,8);
      outtextxy(60,170,'G');
      outtextxy(120,170,'A');
      outtextxy(180,170,'M');
      outtextxy(250,170,'E');
      outtextxy(350,170,'O');
      outtextxy(410,170,'V');
      outtextxy(470,170,'E');
      outtextxy(530,170,'R');
      downscroll(60,'G');
      downscroll(120,'A');
      downscroll(180,'M');
      downscroll(250,'E');
      downscroll(350,'O');
      downscroll(410,'V');
      downscroll(470,'E');
      downscroll(530,'R');
     closegraph;
end.